local f = CreateFrame("Frame")
f:SetPoint("TOPLEFT", 600, -75)
f:SetSize(200, 50)
local text = f:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
text:SetPoint("TOPLEFT", 0, 0)
local marked = {}
local slaves = {}
local master = "Ant"
local player = UnitName("player")
local init = false
RegisterAddonMessagePrefix("EnRT_MS")
f:RegisterEvent("UNIT_AURA")
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("ENCOUNTER_START")
f:SetScript("OnEvent", function(self, event, ...)
	if event == "UNIT_AURA" and player == master then
		local unit = ...
		local unitName = UnitName(unit)
		if UnitBuff(unit, GetSpellInfo(201695)) then
			if not EnRT_Contains(marked, unitName) then
				marked[#marked+1] = unitName
				SetRaidTarget(unitName, EnRT_Contains(marked, unitName))
				SendAddonMessage("EnRT_MS", EnRT_Contains(marked, unitName), "WHISPER", unitName)
				if not init then
					init = true
					C_Timer.After(0.1, function(self) 
						EnRT_MS_AssignGroups()
						init = false
					end)
				end
			end
		else
			if EnRT_Contains(marked, unitName) then
				marked[EnRT_Contains(marked, unitName)] = nil
				SetRaidTarget(unitName, 0)
			end
		end
	elseif event == "ENCOUNTER_START" then
		local eID = ...
		if eID == 2048 then
			enabled = true
			master = EnRT_GetRaidLeader()
		end
	elseif event == "CHAT_MSG_ADDON" then
		local prefix, msg, channel, sender = ...
		if prefix == "EnRT_MS" then
			local mark = ""
			if msg == "1" then
				mark = "STAR"
			elseif msg == "2" then
				mark = "CIRCLE"
			elseif msg == "3" then
				mark = "DIAMOND"
			elseif msg == "4" then
				mark = "TRIANGLE"
			end
			text:SetText("\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..msg..":20\124t".." MOVE TO " .. mark.. "\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..msg..":20\124t")
			text:Show()
			PlaySoundFile("Interface\\AddOns\\EndlessRaidTools\\Sound\\"..mark..".ogg", "Master")
			C_Timer.After(8, function(self) 
				text:SetText("")
				text:Hide()
				if player == master then
					slaves = {}
				end 
			end)
		end
	end
end)
--[[
	Checking if a table PGF_Contains a given value and if it does, what index is the value located at
	param(arr) table
	param(value) T - value to check exists
	return boolean or integer / returns false if the table does not contain the value otherwise it returns the index of where the value is locatedd
]]
function EnRT_Contains(arr, value)
	if value == nil then
		return false
	end
	if arr == nil then
		return false
	end
	for k, v in pairs(arr) do
		if v == value then
			return k
		end
	end
	return false
end
function EnRT_MS_AssignGroups()
	local counter = 1
	for i = 1, GetNumGroupMembers() do
		local raider = "raid"..i
		local raiderName = UnitName(raider)
		if not EnRT_Contains(marked, raiderName) and not EnRT_Contains(slaves, raiderName) then
			counter = counter + 1 
			if counter <= 5 then --Assign Star
				slaves[#slaves+1] = raiderName
				SendAddonMessage("EnRT_MS", 1, "WHISPER", raiderName)
			elseif counter <= 9 then --Assign circle
				slaves[#slaves+1] = raiderName
				SendAddonMessage("EnRT_MS", 2, "WHISPER", raiderName)
			elseif counter <= 13 then -- Assign purple
				slaves[#slaves+1] = raiderName
				SendAddonMessage("EnRT_MS", 3, "WHISPER", raiderName)
			elseif counter <= 17 then -- assign triangle
				slaves[#slaves+1] = raiderName
				SendAddonMessage("EnRT_MS", 4, "WHISPER", raiderName)
			end
		end
	end
end